#!run it like this 'perl qb2oscommerce.pl'

use Win32::ODBC;
use Data::Dumper;

use DBI;

# Debug settings
my $debug = 1;
$Data::Dumper::Indent = 3;
my $count = 0;

# Mysql server settings
my $mysqldsn = 'DBI:mysql:oscommerce:hostname';
my $db_user_name = 'username';
my $db_password = 'password';

# Quickbooks QODBC settings
$DSN = "QODBCDSN";
if (!($db = new Win32::ODBC($DSN))){
    print "Error connecting to $DSN\n";
    print "Error: " . Win32::ODBC::Error() . "\n";
    exit;
}

# Setup and execute query to list all Items from quickbooks.
$SqlStatement = "SELECT * FROM ItemInventory";
if ($db->Sql($SqlStatement)){
    print "SQL failed.\n";
    print "Error: " . $db->Error() . "\n";
    $db->Close();
    exit;
}

my $dbh = DBI->connect($mysqldsn, $db_user_name, $db_password);

# Loop through all Items
while ($db->FetchRow()){
    undef %Data;
    %Data = $db->DataHash();

    if (!defined($Data{'CustomFieldWebProductId'})) {
        # Tell the user what we are doing
        print $Data{'FullName'} . " - " . find_product_id($Data) . "\n";
    }
}

# Close the quickbooks link
$db->Close();
undef $db;
exit;


sub find_product_id {
    ($Data) = @_;

    if (defined($Data{'CustomFieldWebProductId'})) {
        $products_id = $Data{'CustomFieldWebProductId'};
        print "ID: " . $products_id if $debug > 0;
    } else {
        if ($Data{'PurchaseDesc'} =~ /category/i) {
            $query = ("SELECT categories_id " .
                      "FROM categories_description " .
                      "WHERE categories_name = '" . $Data{'FullName'} . "'");
            my $sth = $dbh->prepare($query);
            $sth->execute();
            
            undef $products_id;
            
            # Were there any rows returned?
            if ($sth->rows > 0) {
                $ref = $sth->fetchrow_hashref();
                $products_id = $$ref{'categories_id'};
                print "CID: "; # . $products_id if $debug > 0;
            }
        } else {
            $query = ("SELECT products_id " .
                      "FROM products_description " .
                      "WHERE products_name = '" . $Data{'Name'} . "'");
            my $sth = $dbh->prepare($query);
            $sth->execute();
            
            undef $products_id;
            
            # Were there any rows returned?
            if ($sth->rows > 0) {
                $ref = $sth->fetchrow_hashref();
                $products_id = $$ref{'products_id'};
                print "PID: "; # . $products_id if $debug > 0;
            }
        }
    }
    return $products_id;
}
